# -*- coding: utf-8 -*-
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal
from bitarray import bitarray
import six

# PY3 support of some PY2 keywords (needs improved)
if six.PY3:
  import builtins as __builtin__
  long = int
elif six.PY2:
  import __builtin__

class yc_permitVlan_portChannel_schema__PORTCHANNEL_permitVlan(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module portChannel_schema - based on the path /PORTCHANNEL/permitVlan. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__vlan_name','__taggingMode',)

  _yang_name = 'permitVlan'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    helper = kwargs.pop("path_helper", None)
    if helper is False:
      self._path_helper = False
    elif helper is not None and isinstance(helper, xpathhelper.YANGPathHelper):
      self._path_helper = helper
    elif hasattr(self, "_parent"):
      helper = getattr(self._parent, "_path_helper", False)
      self._path_helper = helper
    else:
      self._path_helper = False

    self._extmethods = False
    self.__vlan_name = YANGDynClass(base=ReferenceType(referenced_path='/vlan-schema:VLAN/vlan-schema:name__', caller=self._path() + ['vlan_name'], path_helper=self._path_helper, require_instance=True), is_leaf=True, yang_name="vlan_name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='leafref', is_config=True)
    self.__taggingMode = YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'untagged': {}, u'tagged': {}},), is_leaf=True, yang_name="taggingMode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:taggingMode', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'PORTCHANNEL', u'permitVlan']

  def _get_vlan_name(self):
    """
    Getter method for vlan_name, mapped from YANG variable /PORTCHANNEL/permitVlan/vlan_name (leafref)
    """
    return self.__vlan_name
      
  def _set_vlan_name(self, v, load=False):
    """
    Setter method for vlan_name, mapped from YANG variable /PORTCHANNEL/permitVlan/vlan_name (leafref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_vlan_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_vlan_name() directly.
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=ReferenceType(referenced_path='/vlan-schema:VLAN/vlan-schema:name__', caller=self._path() + ['vlan_name'], path_helper=self._path_helper, require_instance=True), is_leaf=True, yang_name="vlan_name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='leafref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """vlan_name must be of a type compatible with leafref""",
          'defined-type': "leafref",
          'generated-type': """YANGDynClass(base=ReferenceType(referenced_path='/vlan-schema:VLAN/vlan-schema:name__', caller=self._path() + ['vlan_name'], path_helper=self._path_helper, require_instance=True), is_leaf=True, yang_name="vlan_name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='leafref', is_config=True)""",
        })

    self.__vlan_name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_vlan_name(self):
    self.__vlan_name = YANGDynClass(base=ReferenceType(referenced_path='/vlan-schema:VLAN/vlan-schema:name__', caller=self._path() + ['vlan_name'], path_helper=self._path_helper, require_instance=True), is_leaf=True, yang_name="vlan_name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='leafref', is_config=True)


  def _get_taggingMode(self):
    """
    Getter method for taggingMode, mapped from YANG variable /PORTCHANNEL/permitVlan/taggingMode (common:taggingMode)
    """
    return self.__taggingMode
      
  def _set_taggingMode(self, v, load=False):
    """
    Setter method for taggingMode, mapped from YANG variable /PORTCHANNEL/permitVlan/taggingMode (common:taggingMode)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_taggingMode is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_taggingMode() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'untagged': {}, u'tagged': {}},), is_leaf=True, yang_name="taggingMode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:taggingMode', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """taggingMode must be of a type compatible with common:taggingMode""",
          'defined-type': "common:taggingMode",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'untagged': {}, u'tagged': {}},), is_leaf=True, yang_name="taggingMode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:taggingMode', is_config=True)""",
        })

    self.__taggingMode = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_taggingMode(self):
    self.__taggingMode = YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'untagged': {}, u'tagged': {}},), is_leaf=True, yang_name="taggingMode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:taggingMode', is_config=True)

  vlan_name = __builtin__.property(_get_vlan_name, _set_vlan_name)
  taggingMode = __builtin__.property(_get_taggingMode, _set_taggingMode)


  _pyangbind_elements = OrderedDict([('vlan_name', vlan_name), ('taggingMode', taggingMode), ])


class yc_PORTCHANNEL_portChannel_schema__PORTCHANNEL(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module portChannel_schema - based on the path /PORTCHANNEL. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__name__','__ipv4Address','__ipv6Address','__adminStatus','__mtu','__dhcpRelaySrcIP','__dhcpSever','__ndpProxy','__permitVlan',)

  _yang_name = 'PORTCHANNEL'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    helper = kwargs.pop("path_helper", None)
    if helper is False:
      self._path_helper = False
    elif helper is not None and isinstance(helper, xpathhelper.YANGPathHelper):
      self._path_helper = helper
    elif hasattr(self, "_parent"):
      helper = getattr(self._parent, "_path_helper", False)
      self._path_helper = helper
    else:
      self._path_helper = False

    self._extmethods = False
    self.__ipv4Address = YANGDynClass(unique=True, base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'})), is_leaf=False, yang_name="ipv4Address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ipv4-prefix', is_config=True)
    self.__adminStatus = YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'down': {}, u'up': {}},), is_leaf=True, yang_name="adminStatus", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:status', is_config=True)
    self.__ndpProxy = YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'enable': {}, u'disable': {}},), is_leaf=True, yang_name="ndpProxy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:enable-status', is_config=True)
    self.__ipv6Address = YANGDynClass(unique=True, base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))'})), is_leaf=False, yang_name="ipv6Address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ipv6-prefix', is_config=True)
    self.__name__ = YANGDynClass(base=six.text_type, is_leaf=True, yang_name="name__", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='string', is_config=True)
    self.__mtu = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={u'range': [u'64 .. 9216']}), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='mtu', is_config=True)
    self.__permitVlan = YANGDynClass(base=YANGListType("vlan_name",yc_permitVlan_portChannel_schema__PORTCHANNEL_permitVlan, yang_name="permitVlan", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='vlan_name', extensions=None), is_container='list', yang_name="permitVlan", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='list', is_config=True)
    self.__dhcpSever = YANGDynClass(unique=True, base=TypedListType(allowed_type=[RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}),RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-f]{0,4}):)([0-9a-f]{0,4}:){0,5}((([0-9a-f]{0,4}:)?(:|[0-9a-f]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}),]), is_leaf=False, yang_name="dhcpSever", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ip-address', is_config=True)
    self.__dhcpRelaySrcIP = YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}),RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-f]{0,4}):)([0-9a-f]{0,4}:){0,5}((([0-9a-f]{0,4}:)?(:|[0-9a-f]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}),], is_leaf=True, yang_name="dhcpRelaySrcIP", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ip-address', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'PORTCHANNEL']

  def _get_name__(self):
    """
    Getter method for name__, mapped from YANG variable /PORTCHANNEL/name__ (string)
    """
    return self.__name__
      
  def _set_name__(self, v, load=False):
    """
    Setter method for name__, mapped from YANG variable /PORTCHANNEL/name__ (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_name__ is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_name__() directly.
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=six.text_type, is_leaf=True, yang_name="name__", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='string', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """name__ must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=six.text_type, is_leaf=True, yang_name="name__", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='string', is_config=True)""",
        })

    self.__name__ = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_name__(self):
    self.__name__ = YANGDynClass(base=six.text_type, is_leaf=True, yang_name="name__", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='string', is_config=True)


  def _get_ipv4Address(self):
    """
    Getter method for ipv4Address, mapped from YANG variable /PORTCHANNEL/ipv4Address (inet:ipv4-prefix)
    """
    return self.__ipv4Address
      
  def _set_ipv4Address(self, v, load=False):
    """
    Setter method for ipv4Address, mapped from YANG variable /PORTCHANNEL/ipv4Address (inet:ipv4-prefix)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ipv4Address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ipv4Address() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,unique=True, base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'})), is_leaf=False, yang_name="ipv4Address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ipv4-prefix', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ipv4Address must be of a type compatible with inet:ipv4-prefix""",
          'defined-type': "inet:ipv4-prefix",
          'generated-type': """YANGDynClass(unique=True, base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'})), is_leaf=False, yang_name="ipv4Address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ipv4-prefix', is_config=True)""",
        })

    self.__ipv4Address = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ipv4Address(self):
    self.__ipv4Address = YANGDynClass(unique=True, base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'})), is_leaf=False, yang_name="ipv4Address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ipv4-prefix', is_config=True)


  def _get_ipv6Address(self):
    """
    Getter method for ipv6Address, mapped from YANG variable /PORTCHANNEL/ipv6Address (inet:ipv6-prefix)
    """
    return self.__ipv6Address
      
  def _set_ipv6Address(self, v, load=False):
    """
    Setter method for ipv6Address, mapped from YANG variable /PORTCHANNEL/ipv6Address (inet:ipv6-prefix)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ipv6Address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ipv6Address() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,unique=True, base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))'})), is_leaf=False, yang_name="ipv6Address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ipv6-prefix', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ipv6Address must be of a type compatible with inet:ipv6-prefix""",
          'defined-type': "inet:ipv6-prefix",
          'generated-type': """YANGDynClass(unique=True, base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))'})), is_leaf=False, yang_name="ipv6Address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ipv6-prefix', is_config=True)""",
        })

    self.__ipv6Address = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ipv6Address(self):
    self.__ipv6Address = YANGDynClass(unique=True, base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))'})), is_leaf=False, yang_name="ipv6Address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ipv6-prefix', is_config=True)


  def _get_adminStatus(self):
    """
    Getter method for adminStatus, mapped from YANG variable /PORTCHANNEL/adminStatus (common:status)
    """
    return self.__adminStatus
      
  def _set_adminStatus(self, v, load=False):
    """
    Setter method for adminStatus, mapped from YANG variable /PORTCHANNEL/adminStatus (common:status)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_adminStatus is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_adminStatus() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'down': {}, u'up': {}},), is_leaf=True, yang_name="adminStatus", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:status', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """adminStatus must be of a type compatible with common:status""",
          'defined-type': "common:status",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'down': {}, u'up': {}},), is_leaf=True, yang_name="adminStatus", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:status', is_config=True)""",
        })

    self.__adminStatus = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_adminStatus(self):
    self.__adminStatus = YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'down': {}, u'up': {}},), is_leaf=True, yang_name="adminStatus", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:status', is_config=True)


  def _get_mtu(self):
    """
    Getter method for mtu, mapped from YANG variable /PORTCHANNEL/mtu (mtu)
    """
    return self.__mtu
      
  def _set_mtu(self, v, load=False):
    """
    Setter method for mtu, mapped from YANG variable /PORTCHANNEL/mtu (mtu)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mtu is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mtu() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={u'range': [u'64 .. 9216']}), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='mtu', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mtu must be of a type compatible with mtu""",
          'defined-type': "portChannel_schema:mtu",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={u'range': [u'64 .. 9216']}), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='mtu', is_config=True)""",
        })

    self.__mtu = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mtu(self):
    self.__mtu = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), restriction_dict={u'range': [u'64 .. 9216']}), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='mtu', is_config=True)


  def _get_dhcpRelaySrcIP(self):
    """
    Getter method for dhcpRelaySrcIP, mapped from YANG variable /PORTCHANNEL/dhcpRelaySrcIP (inet:ip-address)
    """
    return self.__dhcpRelaySrcIP
      
  def _set_dhcpRelaySrcIP(self, v, load=False):
    """
    Setter method for dhcpRelaySrcIP, mapped from YANG variable /PORTCHANNEL/dhcpRelaySrcIP (inet:ip-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_dhcpRelaySrcIP is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_dhcpRelaySrcIP() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=[RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}),RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-f]{0,4}):)([0-9a-f]{0,4}:){0,5}((([0-9a-f]{0,4}:)?(:|[0-9a-f]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}),], is_leaf=True, yang_name="dhcpRelaySrcIP", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ip-address', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """dhcpRelaySrcIP must be of a type compatible with inet:ip-address""",
          'defined-type': "inet:ip-address",
          'generated-type': """YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}),RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-f]{0,4}):)([0-9a-f]{0,4}:){0,5}((([0-9a-f]{0,4}:)?(:|[0-9a-f]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}),], is_leaf=True, yang_name="dhcpRelaySrcIP", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ip-address', is_config=True)""",
        })

    self.__dhcpRelaySrcIP = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_dhcpRelaySrcIP(self):
    self.__dhcpRelaySrcIP = YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}),RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-f]{0,4}):)([0-9a-f]{0,4}:){0,5}((([0-9a-f]{0,4}:)?(:|[0-9a-f]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}),], is_leaf=True, yang_name="dhcpRelaySrcIP", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ip-address', is_config=True)


  def _get_dhcpSever(self):
    """
    Getter method for dhcpSever, mapped from YANG variable /PORTCHANNEL/dhcpSever (inet:ip-address)
    """
    return self.__dhcpSever
      
  def _set_dhcpSever(self, v, load=False):
    """
    Setter method for dhcpSever, mapped from YANG variable /PORTCHANNEL/dhcpSever (inet:ip-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_dhcpSever is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_dhcpSever() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,unique=True, base=TypedListType(allowed_type=[RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}),RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-f]{0,4}):)([0-9a-f]{0,4}:){0,5}((([0-9a-f]{0,4}:)?(:|[0-9a-f]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}),]), is_leaf=False, yang_name="dhcpSever", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ip-address', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """dhcpSever must be of a type compatible with inet:ip-address""",
          'defined-type': "inet:ip-address",
          'generated-type': """YANGDynClass(unique=True, base=TypedListType(allowed_type=[RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}),RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-f]{0,4}):)([0-9a-f]{0,4}:){0,5}((([0-9a-f]{0,4}:)?(:|[0-9a-f]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}),]), is_leaf=False, yang_name="dhcpSever", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ip-address', is_config=True)""",
        })

    self.__dhcpSever = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_dhcpSever(self):
    self.__dhcpSever = YANGDynClass(unique=True, base=TypedListType(allowed_type=[RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}),RestrictedClassType(base_type=six.text_type, restriction_dict={u'pattern': u'((:|[0-9a-f]{0,4}):)([0-9a-f]{0,4}:){0,5}((([0-9a-f]{0,4}:)?(:|[0-9a-f]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}),]), is_leaf=False, yang_name="dhcpSever", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='inet:ip-address', is_config=True)


  def _get_ndpProxy(self):
    """
    Getter method for ndpProxy, mapped from YANG variable /PORTCHANNEL/ndpProxy (common:enable-status)
    """
    return self.__ndpProxy
      
  def _set_ndpProxy(self, v, load=False):
    """
    Setter method for ndpProxy, mapped from YANG variable /PORTCHANNEL/ndpProxy (common:enable-status)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ndpProxy is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ndpProxy() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'enable': {}, u'disable': {}},), is_leaf=True, yang_name="ndpProxy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:enable-status', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ndpProxy must be of a type compatible with common:enable-status""",
          'defined-type': "common:enable-status",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'enable': {}, u'disable': {}},), is_leaf=True, yang_name="ndpProxy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:enable-status', is_config=True)""",
        })

    self.__ndpProxy = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ndpProxy(self):
    self.__ndpProxy = YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={u'enable': {}, u'disable': {}},), is_leaf=True, yang_name="ndpProxy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='common:enable-status', is_config=True)


  def _get_permitVlan(self):
    """
    Getter method for permitVlan, mapped from YANG variable /PORTCHANNEL/permitVlan (list)
    """
    return self.__permitVlan
      
  def _set_permitVlan(self, v, load=False):
    """
    Setter method for permitVlan, mapped from YANG variable /PORTCHANNEL/permitVlan (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_permitVlan is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_permitVlan() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("vlan_name",yc_permitVlan_portChannel_schema__PORTCHANNEL_permitVlan, yang_name="permitVlan", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='vlan_name', extensions=None), is_container='list', yang_name="permitVlan", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """permitVlan must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("vlan_name",yc_permitVlan_portChannel_schema__PORTCHANNEL_permitVlan, yang_name="permitVlan", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='vlan_name', extensions=None), is_container='list', yang_name="permitVlan", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='list', is_config=True)""",
        })

    self.__permitVlan = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_permitVlan(self):
    self.__permitVlan = YANGDynClass(base=YANGListType("vlan_name",yc_permitVlan_portChannel_schema__PORTCHANNEL_permitVlan, yang_name="permitVlan", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='vlan_name', extensions=None), is_container='list', yang_name="permitVlan", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='list', is_config=True)

  name__ = __builtin__.property(_get_name__, _set_name__)
  ipv4Address = __builtin__.property(_get_ipv4Address, _set_ipv4Address)
  ipv6Address = __builtin__.property(_get_ipv6Address, _set_ipv6Address)
  adminStatus = __builtin__.property(_get_adminStatus, _set_adminStatus)
  mtu = __builtin__.property(_get_mtu, _set_mtu)
  dhcpRelaySrcIP = __builtin__.property(_get_dhcpRelaySrcIP, _set_dhcpRelaySrcIP)
  dhcpSever = __builtin__.property(_get_dhcpSever, _set_dhcpSever)
  ndpProxy = __builtin__.property(_get_ndpProxy, _set_ndpProxy)
  permitVlan = __builtin__.property(_get_permitVlan, _set_permitVlan)


  _pyangbind_elements = OrderedDict([('name__', name__), ('ipv4Address', ipv4Address), ('ipv6Address', ipv6Address), ('adminStatus', adminStatus), ('mtu', mtu), ('dhcpRelaySrcIP', dhcpRelaySrcIP), ('dhcpSever', dhcpSever), ('ndpProxy', ndpProxy), ('permitVlan', permitVlan), ])


class portChannel_schema(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module portChannel_schema - based on the path /portChannel_schema. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_path_helper', '_extmethods', '__PORTCHANNEL',)

  _yang_name = 'portChannel_schema'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    helper = kwargs.pop("path_helper", None)
    if helper is False:
      self._path_helper = False
    elif helper is not None and isinstance(helper, xpathhelper.YANGPathHelper):
      self._path_helper = helper
    elif hasattr(self, "_parent"):
      helper = getattr(self._parent, "_path_helper", False)
      self._path_helper = helper
    else:
      self._path_helper = False

    self._extmethods = False
    self.__PORTCHANNEL = YANGDynClass(base=YANGListType("name__",yc_PORTCHANNEL_portChannel_schema__PORTCHANNEL, yang_name="PORTCHANNEL", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name__', extensions=None), is_container='list', yang_name="PORTCHANNEL", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return []

  def _get_PORTCHANNEL(self):
    """
    Getter method for PORTCHANNEL, mapped from YANG variable /PORTCHANNEL (list)
    """
    return self.__PORTCHANNEL
      
  def _set_PORTCHANNEL(self, v, load=False):
    """
    Setter method for PORTCHANNEL, mapped from YANG variable /PORTCHANNEL (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_PORTCHANNEL is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_PORTCHANNEL() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("name__",yc_PORTCHANNEL_portChannel_schema__PORTCHANNEL, yang_name="PORTCHANNEL", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name__', extensions=None), is_container='list', yang_name="PORTCHANNEL", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """PORTCHANNEL must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("name__",yc_PORTCHANNEL_portChannel_schema__PORTCHANNEL, yang_name="PORTCHANNEL", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name__', extensions=None), is_container='list', yang_name="PORTCHANNEL", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='list', is_config=True)""",
        })

    self.__PORTCHANNEL = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_PORTCHANNEL(self):
    self.__PORTCHANNEL = YANGDynClass(base=YANGListType("name__",yc_PORTCHANNEL_portChannel_schema__PORTCHANNEL, yang_name="PORTCHANNEL", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='name__', extensions=None), is_container='list', yang_name="PORTCHANNEL", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://north-api.aliababa.com/schema/portChannel/', defining_module='portChannel_schema', yang_type='list', is_config=True)

  PORTCHANNEL = __builtin__.property(_get_PORTCHANNEL, _set_PORTCHANNEL)


  _pyangbind_elements = OrderedDict([('PORTCHANNEL', PORTCHANNEL), ])


